#
#
# Handle some trivial cases.. The _really_ trivial cases have
-# been handled already by read-tree, but that one doesn't
+# been handled already by git-read-tree, but that one doesn't
# do any merges that migth change the tree layout
#
# if the directory is newly added in a branch, it might not exist
# in the current tree
dir=$(dirname "$4")
-mkdir -p "$dir"
+mkdir -p "$dir" || exit
case "${1:-.}${2:-.}${3:-.}" in
#
# deleted in one and unchanged in the other
#
"$1.." | "$1.$1" | "$1$1.")
- rm -f -- "$4"
echo "Removing $4"
- update-cache --remove -- "$4"
- exit 0
- ;;
-
+ rm -f -- "$4" && exec git-update-cache --remove -- "$4" ;;
#
# added in one
#
".$2." | "..$3" )
- echo "Adding $4 with perm $6$7"
- mv $(unpack-file "$2$3") $4
- chmod "$6$7" $4
- update-cache --add -- $4
- exit 0
- ;;
+ case "$6$7" in *7??) mode=+x;; *) mode=-x;; esac
+ echo "Adding $4 with perm $mode"
+ rm -f -- "$4" &&
+ git-cat-file blob "$2$3" >"$4" &&
+ chmod "$mode" -- "$4" &&
+ exec git-update-cache --add -- "$4" ;;
#
# Added in both (check for same permissions)
#
echo "ERROR: File $4 added in both branches, permissions conflict $6->$7"
exit 1
fi
- echo "Adding $4 with perm $6"
- mv $(unpack-file "$2") $4
- chmod "$6" $4
- update-cache --add -- $4
- exit 0;;
+ case "$6" in *7??) mode=+x;; *) mode=-x;; esac
+ echo "Adding $4 with perm $mode"
+ rm -f -- "$4" &&
+ git-cat-file blob "$2" >"$4" &&
+ chmod "$mode" -- "$4" &&
+ exec git-update-cache --add -- "$4" ;;
#
# Modified in both, but differently ;(
#
"$1$2$3")
echo "Auto-merging $4"
- orig=$(unpack-file $1)
- src1=$(unpack-file $2)
- src2=$(unpack-file $3)
+ orig=$(git-unpack-file $1)
+ src1=$(git-unpack-file $2)
+ src2=$(git-unpack-file $3)
merge "$src2" "$orig" "$src1"
ret=$?
if [ "$6" != "$7" ]; then
fi
exit 1
fi
- chmod -- "$6" "$src2"
if [ $ret -ne 0 ]; then
echo "ERROR: Leaving conflict merge in $src2"
exit 1
fi
- cp -- "$src2" "$4" && chmod -- "$6" "$4" && update-cache --add -- "$4" && exit 0
- ;;
-
+ case "$6" in *7??) mode=+x;; *) mode=-x;; esac
+ rm -f -- "$4" && cat "$src2" >"$4" && chmod "$mode" -- "$4" &&
+ exec git-update-cache --add -- "$4" ;;
*)
- echo "Not handling case $1 -> $2 -> $3"
- ;;
+ echo "Not handling case $4: $1 -> $2 -> $3" ;;
esac
exit 1